Index: /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcblk_core.F90
===================================================================
--- /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 1858)
+++ /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 1859)
@@ -12,4 +12,5 @@
    !!            3.0  !  2006-06  (G. Madec) sbc rewritting   
    !!            3.2  !  2009-04  (B. Lemaire)  Introduce iom_put
+   !!            3.3  !  2010-05  (Y. Aksenov G. Madec) salt flux + heat associated with emp
    !!----------------------------------------------------------------------
 
@@ -45,5 +46,5 @@
    INTEGER , PARAMETER ::   jp_wndi = 1           ! index of 10m wind velocity (i-component) (m/s)    at T-point
    INTEGER , PARAMETER ::   jp_wndj = 2           ! index of 10m wind velocity (j-component) (m/s)    at T-point
-   INTEGER , PARAMETER ::   jp_humi = 3           ! index of specific humidity               ( - )
+   INTEGER , PARAMETER ::   jp_humi = 3           ! index of specific humidity               ( % )
    INTEGER , PARAMETER ::   jp_qsr  = 4           ! index of solar heat                      (W/m2)
    INTEGER , PARAMETER ::   jp_qlw  = 5           ! index of Long wave                       (W/m2)
@@ -62,8 +63,8 @@
    REAL(wp), PARAMETER ::   Cice =    1.63e-3     ! transfer coefficient over ice
 
-   !                                !!* Namelist namsbc_core : CORE bulk parameters
-   LOGICAL  ::   ln_2m     = .FALSE.     ! logical flag for height of air temp. and hum
-   LOGICAL  ::   ln_taudif = .FALSE.     ! logical flag to use the "mean of stress module - module of mean stress" data
-   REAL(wp) ::   rn_pfac   = 1.          ! multiplication factor for precipitation
+   !                                    !!* Namelist namsbc_core : CORE bulk parameters
+   LOGICAL  ::   ln_2m     = .FALSE.     ! air temperature and humidity given at 2m (T) or 10m (F)
+   LOGICAL  ::   ln_taudif = .FALSE.     ! (T) use the "mean of stress module - module of mean stress" data or (F) not
+   REAL(wp) ::   rn_pfac   = 1.          ! multiplicative factor for precipitation
 
    !! * Substitutions
@@ -71,5 +72,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
@@ -88,36 +89,32 @@
       !!      the 10m wind velocity (i-component) (m/s)    at T-point
       !!      the 10m wind velocity (j-component) (m/s)    at T-point
-      !!      the specific humidity               ( - )
+      !!      the 10m or 2m specific humidity     ( % )
       !!      the solar heat                      (W/m2)
       !!      the Long wave                       (W/m2)
-      !!      the 10m air temperature             (Kelvin)
+      !!      the 10m or 2m air temperature       (Kelvin)
       !!      the total precipitation (rain+snow) (Kg/m2/s)
       !!      the snow (solid prcipitation)       (kg/m2/s)
-      !!   OPTIONAL parameter (see ln_taudif namelist flag):
-      !!      the tau diff associated to HF tau   (N/m2)   at T-point 
+      !!      the tau diff associated to HF tau   (N/m2)   at T-point   (ln_taudif=T)
       !!              (2) CALL blk_oce_core
       !!
       !!      C A U T I O N : never mask the surface stress fields
-      !!                      the stress is assumed to be in the mesh referential
-      !!                      i.e. the (i,j) referential
+      !!                      the stress is assumed to be in the (i,j) mesh referential
       !!
       !! ** Action  :   defined at each time-step at the air-sea interface
       !!              - utau, vtau  i- and j-component of the wind stress
-      !!              - taum        wind stress module at T-point
-      !!              - wndm        10m wind module at T-point
-      !!              - qns, qsr    non-slor and solar heat flux
-      !!              - emp, emps   evaporation minus precipitation
+      !!              - taum, wndm  wind stress and 10m wind modules at T-point
+      !!              - qns, qsr    non-solar and solar heat flux
+      !!              - emp         upward mass flux (evapo. - precip.)
       !!----------------------------------------------------------------------
       INTEGER, INTENT( in  ) ::   kt   ! ocean time step
       !!
+      INTEGER  ::   jf       ! dummy loop indice
+      INTEGER  ::   ifld     ! number of files to be read
       INTEGER  ::   ierror   ! return error code
-      INTEGER  ::   ifpr     ! dummy loop indice
-      INTEGER  ::   jfld     ! dummy loop arguments
       !!
       CHARACTER(len=100) ::  cn_dir   !   Root directory for location of core files
       TYPE(FLD_N), DIMENSION(jpfld) ::   slf_i     ! array of namelist informations on the fields to read
-      TYPE(FLD_N) ::   sn_wndi, sn_wndj, sn_humi, sn_qsr       ! informations about the fields to be read
-      TYPE(FLD_N) ::   sn_qlw , sn_tair, sn_prec, sn_snow      !   "                                 "
-      TYPE(FLD_N) ::   sn_tdif                                 !   "                                 "
+      TYPE(FLD_N) ::   sn_wndi, sn_wndj, sn_humi, sn_qsr             ! informations about the fields to be read
+      TYPE(FLD_N) ::   sn_qlw , sn_tair, sn_prec, sn_snow, sn_tdif   !       -                       -
       NAMELIST/namsbc_core/ cn_dir , ln_2m  , ln_taudif, rn_pfac,           &
          &                  sn_wndi, sn_wndj, sn_humi  , sn_qsr ,           &
@@ -156,14 +153,14 @@
          ! do we use HF tau information?
          lhftau = ln_taudif
-         jfld = jpfld - COUNT( (/.NOT. lhftau/) )
+         ifld = jpfld - COUNT( (/.NOT. lhftau/) )
          !
          ! set sf structure
-         ALLOCATE( sf(jfld), STAT=ierror )
+         ALLOCATE( sf(ifld), STAT=ierror )
          IF( ierror > 0 ) THEN
             CALL ctl_stop( 'sbc_blk_core: unable to allocate sf structure' )   ;   RETURN
          ENDIF
-         DO ifpr= 1, jfld
-            ALLOCATE( sf(ifpr)%fnow(jpi,jpj) )
-            ALLOCATE( sf(ifpr)%fdta(jpi,jpj,2) )
+         DO jf = 1, ifld
+            ALLOCATE( sf(jf)%fnow(jpi,jpj) )
+            ALLOCATE( sf(jf)%fdta(jpi,jpj,2) )
          END DO
          !
@@ -173,14 +170,14 @@
       ENDIF
 
+!!gm    all the below lines should be executed only at nn_fbc frequency, no???   check fldread capability
+
       CALL fld_read( kt, nn_fsbc, sf )                   ! input fields provided at the current time-step
-
+      !
 #if defined key_lim3
-      tatm_ice(:,:) = sf(jp_tair)%fnow(:,:)
+      tatm_ice(:,:) = sf(jp_tair)%fnow(:,:)              ! air temperature over ice (LIM3 only)
 #endif
-
-      IF( MOD( kt - 1, nn_fsbc ) == 0 ) THEN
-          CALL blk_oce_core( sf, sst_m, ssu_m, ssv_m )   ! compute the surface ocean fluxes using CLIO bulk formulea
-      ENDIF
-      !                                                  ! using CORE bulk formulea
+      !                                                  ! surface ocean fluxes using CORE bulk formulea
+      IF( MOD( kt - 1, nn_fsbc ) == 0 )   CALL blk_oce_core( sf, sst_m, ssu_m, ssv_m )
+      !
    END SUBROUTINE sbc_blk_core
    
@@ -196,23 +193,23 @@
       !!      fields read in sbc_read
       !! 
-      !! ** Outputs : - utau    : i-component of the stress at U-point  (N/m2)
-      !!              - vtau    : j-component of the stress at V-point  (N/m2)
-      !!              - taum    : Wind stress module at T-point         (N/m2)
-      !!              - wndm    : Wind speed module at T-point          (m/s)
-      !!              - qsr     : Solar heat flux over the ocean        (W/m2)
-      !!              - qns     : Non Solar heat flux over the ocean    (W/m2)
-      !!              - evap    : Evaporation over the ocean            (kg/m2/s)
-      !!              - emp(s)  : evaporation minus precipitation       (kg/m2/s)
+      !! ** Action  : - utau  : i-component of the stress at U-point  (N/m2)
+      !!              - vtau  : j-component of the stress at V-point  (N/m2)
+      !!              - taum  : Wind stress module at T-point         (N/m2)
+      !!              - wndm  : 10m Wind speed module at T-point      (m/s)
+      !!              - qsr   : Solar heat flux over the ocean        (W/m2)
+      !!              - qns   : Non Solar heat flux over the ocean    (W/m2)
+      !!                        including the latent heat of solid 
+      !!                        precip. melting and emp heat content
+      !!              - emp   : upward mass flux (evap. - precip.)    (kg/m2/s)
       !!
       !!  ** Nota  :   sf has to be a dummy argument for AGRIF on NEC
       !!---------------------------------------------------------------------
-      TYPE(fld), INTENT(in), DIMENSION(:)       ::   sf    ! input data
-      REAL(wp),  INTENT(in), DIMENSION(jpi,jpj) ::   pst   ! surface temperature                      [Celcius]
-      REAL(wp),  INTENT(in), DIMENSION(jpi,jpj) ::   pu    ! surface current at U-point (i-component) [m/s]
-      REAL(wp),  INTENT(in), DIMENSION(jpi,jpj) ::   pv    ! surface current at V-point (j-component) [m/s]
-
+      TYPE(fld), INTENT(in), DIMENSION(:)       ::   sf    ! input data (forcing field structure)
+      REAL(wp) , INTENT(in), DIMENSION(jpi,jpj) ::   pst   ! surface temperature                      [Celcius]
+      REAL(wp) , INTENT(in), DIMENSION(jpi,jpj) ::   pu    ! surface current at U-point (i-component) [m/s]
+      REAL(wp) , INTENT(in), DIMENSION(jpi,jpj) ::   pv    ! surface current at V-point (j-component) [m/s]
+      !!
       INTEGER  ::   ji, jj     ! dummy loop indices
-      REAL(wp) ::   zcoef_qsatw
-      REAL(wp) ::   zztmp                                 ! temporary variable
+      REAL(wp) ::   zcoef_qsatw, zztmp                    ! temporary scalar
       REAL(wp), DIMENSION(jpi,jpj) ::   zwnd_i, zwnd_j    ! wind speed components at T-point
       REAL(wp), DIMENSION(jpi,jpj) ::   zqsatw            ! specific humidity at pst
@@ -230,5 +227,5 @@
       zcoef_qsatw = 0.98 * 640380. / rhoa
       
-      zst(:,:) = pst(:,:) + rt0      ! converte Celcius to Kelvin (and set minimum value far above 0 K)
+      zst(:,:) = pst(:,:) + rt0      ! converte SST from Celcius to Kelvin (and set minimum value far above 0 K)
 
       ! ----------------------------------------------------------------------------- !
@@ -262,5 +259,5 @@
       ! ocean albedo assumed to be 0.066
 !CDIR COLLAPSE
-      qsr (:,:) = ( 1. - 0.066 ) * sf(jp_qsr)%fnow(:,:) * tmask(:,:,1)                                 ! Short Wave
+      qsr (:,:) = ( 1. - 0.066 ) * sf(jp_qsr)%fnow(:,:) * tmask(:,:,1)                                     ! Short Wave
 !CDIR COLLAPSE
       zqlw(:,:) = (  sf(jp_qlw)%fnow(:,:) - Stef * zst(:,:)*zst(:,:)*zst(:,:)*zst(:,:)  ) * tmask(:,:,1)   ! Long  Wave
@@ -353,9 +350,14 @@
      
 !CDIR COLLAPSE
-      qns(:,:) = zqlw(:,:) - zqsb(:,:) - zqla(:,:)      ! Downward Non Solar flux
-!CDIR COLLAPSE
-      emp (:,:) = zevap(:,:) - sf(jp_prec)%fnow(:,:) * rn_pfac * tmask(:,:,1)
-!CDIR COLLAPSE
-      emps(:,:) = emp(:,:)
+      emp (:,:) = (  zevap(:,:)                                          &   ! mass flux (evap. - precip.)
+         &         - sf(jp_prec)%fnow(:,:) * rn_pfac  ) * tmask(:,:,1)
+!CDIR COLLAPSE
+      qns(:,:) = zqlw(:,:) - zqsb(:,:) - zqla(:,:)                       &   ! Downward Non Solar flux
+         &     - sf(jp_snow)%fnow(:,:) * lfus                            &   ! remove latent melting heat for solid precip
+         &     - zevap(:,:) * pst(ji,jj) * rcp                           &   ! remove evap heat content at SST
+         &     + ( sf(jp_prec)%fnow(:,:) - sf(jp_snow)%fnow(:,:) )       &   ! add liquid precip heat content at Tair
+         &     * ( sf(jp_tair)%fnow(:,:) - rt0 ) * rcp                   &   
+         &     + sf(jp_snow)%fnow(:,:)                                   &   ! add solid  precip heat content at min(Tair,Tsnow)
+         &     * ( MIN( sf(jp_tair)%fnow(:,:), rt0_snow ) - rt0 ) * cpic 
       !
       CALL iom_put( "qlw_oce",   zqlw )                 ! output downward longwave heat over the ocean
@@ -392,34 +394,34 @@
       !! caution : the net upward water flux has with mm/day unit
       !!---------------------------------------------------------------------
-      REAL(wp), INTENT(in   ), DIMENSION(:,:,:)      ::   pst      ! ice surface temperature (>0, =rt0 over land) [Kelvin]
-      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj)    ::   pui      ! ice surface velocity (i- and i- components      [m/s]
-      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj)    ::   pvi      !    at I-point (B-grid) or U & V-point (C-grid)
-      REAL(wp), INTENT(in   ), DIMENSION(:,:,:)      ::   palb     ! ice albedo (clear sky) (alb_ice_cs)               [%]
-      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj)    ::   p_taui   ! i- & j-components of surface ice stress        [N/m2]
-      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj)    ::   p_tauj   !   at I-point (B-grid) or U & V-point (C-grid)
-      REAL(wp), INTENT(  out), DIMENSION(:,:,:)      ::   p_qns    ! non solar heat flux over ice (T-point)         [W/m2]
-      REAL(wp), INTENT(  out), DIMENSION(:,:,:)      ::   p_qsr    !     solar heat flux over ice (T-point)         [W/m2]
-      REAL(wp), INTENT(  out), DIMENSION(:,:,:)      ::   p_qla    ! latent    heat flux over ice (T-point)         [W/m2]
-      REAL(wp), INTENT(  out), DIMENSION(:,:,:)      ::   p_dqns   ! non solar heat sensistivity  (T-point)         [W/m2]
-      REAL(wp), INTENT(  out), DIMENSION(:,:,:)      ::   p_dqla   ! latent    heat sensistivity  (T-point)         [W/m2]
-      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj)    ::   p_tpr    ! total precipitation          (T-point)      [Kg/m2/s]
-      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj)    ::   p_spr    ! solid precipitation          (T-point)      [Kg/m2/s]
-      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj)    ::   p_fr1    ! 1sr fraction of qsr penetration in ice (T-point)  [%]
-      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj)    ::   p_fr2    ! 2nd fraction of qsr penetration in ice (T-point)  [%]
-      CHARACTER(len=1), INTENT(in   )                ::   cd_grid  ! ice grid ( C or B-grid)
-      INTEGER, INTENT(in   )                         ::   pdim     ! number of ice categories
+      REAL(wp), INTENT(in   ), DIMENSION(:,:,:)   ::   pst      ! ice surface temperature (>0, =rt0 over land) [Kelvin]
+      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj) ::   pui      ! ice surface velocity (i- and i- components      [m/s]
+      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj) ::   pvi      !    at I-point (B-grid) or U & V-point (C-grid)
+      REAL(wp), INTENT(in   ), DIMENSION(:,:,:)   ::   palb     ! ice albedo (clear sky) (alb_ice_cs)               [%]
+      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj) ::   p_taui   ! i- & j-components of surface ice stress        [N/m2]
+      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj) ::   p_tauj   !   at I-point (B-grid) or U & V-point (C-grid)
+      REAL(wp), INTENT(  out), DIMENSION(:,:,:)   ::   p_qns    ! non solar heat flux over ice (T-point)         [W/m2]
+      REAL(wp), INTENT(  out), DIMENSION(:,:,:)   ::   p_qsr    !     solar heat flux over ice (T-point)         [W/m2]
+      REAL(wp), INTENT(  out), DIMENSION(:,:,:)   ::   p_qla    ! latent    heat flux over ice (T-point)         [W/m2]
+      REAL(wp), INTENT(  out), DIMENSION(:,:,:)   ::   p_dqns   ! non solar heat sensistivity  (T-point)         [W/m2]
+      REAL(wp), INTENT(  out), DIMENSION(:,:,:)   ::   p_dqla   ! latent    heat sensistivity  (T-point)         [W/m2]
+      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj) ::   p_tpr    ! total precipitation          (T-point)      [Kg/m2/s]
+      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj) ::   p_spr    ! solid precipitation          (T-point)      [Kg/m2/s]
+      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj) ::   p_fr1    ! 1sr fraction of qsr penetration in ice (T-point)  [%]
+      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj) ::   p_fr2    ! 2nd fraction of qsr penetration in ice (T-point)  [%]
+      CHARACTER(len=1), INTENT(in   )             ::   cd_grid  ! ice grid ( C or B-grid)
+      INTEGER, INTENT(in   )                      ::   pdim     ! number of ice categories
       !!
       INTEGER  ::   ji, jj, jl    ! dummy loop indices
       INTEGER  ::   ijpl          ! number of ice categories (size of 3rd dim of input arrays)
-      REAL(wp) ::   zst2, zst3
-      REAL(wp) ::   zcoef_wnorm, zcoef_wnorm2, zcoef_dqlw, zcoef_dqla, zcoef_dqsb
-      REAL(wp) ::   zcoef_frca                                   ! fractional cloud amount
-      REAL(wp) ::   zwnorm_f, zwndi_f , zwndj_f                  ! relative wind module and components at F-point
-      REAL(wp) ::             zwndi_t , zwndj_t                  ! relative wind components at T-point
-      REAL(wp), DIMENSION(jpi,jpj) ::   z_wnds_t                 ! wind speed ( = | U10m - U_ice | ) at T-point
-      REAL(wp), DIMENSION(jpi,jpj,pdim) ::   z_qlw               ! long wave heat flux over ice
-      REAL(wp), DIMENSION(jpi,jpj,pdim) ::   z_qsb               ! sensible  heat flux over ice
-      REAL(wp), DIMENSION(jpi,jpj,pdim) ::   z_dqlw              ! long wave heat sensitivity over ice
-      REAL(wp), DIMENSION(jpi,jpj,pdim) ::   z_dqsb              ! sensible  heat sensitivity over ice
+      REAL(wp) ::   zst2, zcoef_wnorm , zcoef_dqlw              !
+      REAL(wp) ::   zst3, zcoef_wnorm2, zcoef_dqla, zcoef_dqsb  !
+      REAL(wp) ::   zcoef_frca                                  ! fractional cloud amount
+      REAL(wp) ::   zwnorm_f, zwndi_f , zwndj_f                 ! relative wind module and components at F-point
+      REAL(wp) ::             zwndi_t , zwndj_t                 ! relative wind components at T-point
+      REAL(wp), DIMENSION(jpi,jpj)      ::   z_wnds_t           ! wind speed ( = | U10m - U_ice | ) at T-point
+      REAL(wp), DIMENSION(jpi,jpj,pdim) ::   z_qlw              ! long wave heat flux over ice
+      REAL(wp), DIMENSION(jpi,jpj,pdim) ::   z_qsb              ! sensible  heat flux over ice
+      REAL(wp), DIMENSION(jpi,jpj,pdim) ::   z_dqlw             ! long wave heat sensitivity over ice
+      REAL(wp), DIMENSION(jpi,jpj,pdim) ::   z_dqsb             ! sensible  heat sensitivity over ice
       !!---------------------------------------------------------------------
 
@@ -576,10 +578,10 @@
          CALL prt_ctl(tab2d_1=z_wnds_t, clinfo1=' blk_ice_core: z_wnds_t : ')
       ENDIF
-
+      !
    END SUBROUTINE blk_ice_core
   
 
    SUBROUTINE TURB_CORE_1Z(zu, sst, T_a, q_sat, q_a,   &
-      &                        dU, Cd, Ch, Ce   )
+      &                        dU , Cd , Ch   , Ce   )
       !!----------------------------------------------------------------------
       !!                      ***  ROUTINE  turb_core  ***
@@ -704,5 +706,6 @@
 
 
-    SUBROUTINE TURB_CORE_2Z(zt, zu, sst, T_zt, q_sat, q_zt, dU, Cd, Ch, Ce, T_zu, q_zu)
+    SUBROUTINE TURB_CORE_2Z( zt  , zu, sst, T_zt, q_sat,   &
+      &                      q_zt, dU, Cd , Ch  , Ce   , T_zu, q_zu)
       !!----------------------------------------------------------------------
       !!                      ***  ROUTINE  turb_core  ***
@@ -838,7 +841,6 @@
          Ce  = Ce_n10*sqrt_Cd/sqrt_Cd_n10/xct
          !!
-         !!
       END DO
-      !!
+      !
     END SUBROUTINE TURB_CORE_2Z
 
Index: /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbccpl.F90
===================================================================
--- /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 1858)
+++ /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 1859)
@@ -4,7 +4,8 @@
    !! Surface Boundary Condition :  momentum, heat and freshwater fluxes in coupled mode
    !!======================================================================
-   !! History :  2.0  !  06-2007  (R. Redler, N. Keenlyside, W. Park) Original code split into flxmod & taumod
-   !!            3.0  !  02-2008  (G. Madec, C Talandier)  surface module
-   !!            3.1  !  02-2009  (G. Madec, S. Masson, E. Maisonave, A. Caubel) generic coupled interface
+   !! History :  2.0  !  2007-06  (R. Redler, N. Keenlyside, W. Park) Original code split into flxmod & taumod
+   !!            3.0  !  2008-02  (G. Madec, C Talandier)  surface module
+   !!            3.1  !  2009-02  (G. Madec, S. Masson, E. Maisonave, A. Caubel) generic coupled interface
+   !!            3.3  !  2010-05  (Y. Aksenov G. Madec) salt flux + heat associated with emp
    !!----------------------------------------------------------------------
 #if defined key_oasis3 || defined key_oasis4
@@ -156,5 +157,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.0 , LOCEAN-IPSL (2008) 
+   !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
@@ -562,6 +563,8 @@
       !! ** Action  :   update  utau, vtau   ocean stress at U,V grid 
       !!                        taum, wndm   wind stres and wind speed module at T-point
-      !!                        qns , qsr    non solar and solar ocean heat fluxes   ('ocean only case)
-      !!                        emp = emps   evap. - precip. (- runoffs) (- calving) ('ocean only case)
+      !!                        qns          non solar heat fluxes including emp heat content    (ocean only case)
+      !!                                     and the latent heat flux of solid precip. melting
+      !!                        qsr          solar ocean heat fluxes   (ocean only case)
+      !!                        emp          upward mass flux [evap. - precip. (- runoffs) (- calving)] (ocean only case)
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt       ! ocean model time step index
@@ -697,5 +700,5 @@
       ENDIF
 
-      ! u(v)tau and taum will be modified by ice model (wndm will be changed by PISCES)
+      ! u(v)tau and taum will be modified by ice model (and wndm will be changed by PISCES)
       ! -> need to be reset before each call of the ice/fsbc      
       IF( MOD( kt-1, k_fsbc ) == 0 ) THEN
@@ -712,15 +715,5 @@
          !                                                   ! ========================= !
          !
-         !                                                       ! non solar heat flux over the ocean (qns)
-         IF( srcv(jpr_qnsoce)%laction )   qns(:,:) = frcv(:,:,jpr_qnsoce)
-         IF( srcv(jpr_qnsmix)%laction )   qns(:,:) = frcv(:,:,jpr_qnsmix)        
-         !   energy for melting solid precipitation over free ocean
-         zcoef = xlsn / rhosn
-         qns(:,:) = qns(:,:) - frcv(:,:,jpr_snow) * zcoef
-         !                                                       ! solar flux over the ocean          (qsr)
-         IF( srcv(jpr_qsroce)%laction )   qsr(:,:) = frcv(:,:,jpr_qsroce) 
-         IF( srcv(jpr_qsrmix)%laction )   qsr(:,:) = frcv(:,:,jpr_qsrmix)
-         !
-         !                                                       ! total freshwater fluxes over the ocean (emp, emps)
+         !                                                       ! total freshwater fluxes over the ocean (emp)
          SELECT CASE( TRIM( cn_rcv_emp ) )                                    ! evaporation - precipitation
          CASE( 'conservative' )
@@ -752,15 +745,22 @@
 !!         ENDIF
 !!gm  end of internal cooking
-         !
-         emps(:,:) = emp(:,:)                                        ! concentration/dilution = emp
-  
-         !                                                           ! 10 m wind speed
-         IF( srcv(jpr_w10m)%laction )   wndm(:,:) = frcv(:,:,jpr_w10m)
+         !  
+         !                                                       ! non solar heat flux over the ocean (qns)
+         IF( srcv(jpr_qnsoce)%laction )   qns(:,:) = frcv(:,:,jpr_qnsoce)
+         IF( srcv(jpr_qnsmix)%laction )   qns(:,:) = frcv(:,:,jpr_qnsmix)
+         !
+         zcoef = xlsn / rhosn                                    ! qns update over free ocean with:
+         qns(:,:) = qns(:,:) - frcv(:,:,jpr_snow) * zcoef            ! energy for melting solid precipitation over free ocean
+            &                - emp(:,:) * sst_m(:,:) * rcp           ! remove heat content due to mass flux (assumed to be at SST)
+         !
+         !                                                       ! solar flux over the ocean          (qsr)
+         IF( srcv(jpr_qsroce)%laction )   qsr(:,:) = frcv(:,:,jpr_qsroce) 
+         IF( srcv(jpr_qsrmix)%laction )   qsr(:,:) = frcv(:,:,jpr_qsrmix)
          !
 #if defined  key_cpl_carbon_cycle
-         !                                                              ! atmosph. CO2 (ppm)
+         !                                                       ! atmosph. CO2 (ppm)
          IF( srcv(jpr_co2)%laction )   atm_co2(:,:) = frcv(:,:,jpr_co2)
 #endif
-
+         !
       ENDIF
       !
@@ -1046,5 +1046,5 @@
       !!----------------------------------------------------------------------
       zicefr(:,:,1) = 1.- p_frld(:,:,1)
-      IF( lk_diaar5 )   zcptn(:,:) = rcp * tn(:,:,1)
+      zcptn(:,:) = rcp * sst_m(:,:)
       !
       !                                                      ! ========================= !
@@ -1118,23 +1118,22 @@
             &                                                   +          pist(:,:,1)   * zicefr(:,:,1) ) )
       END SELECT
-      !                                                           ! snow melting heat flux ....
-      !   energy for melting solid precipitation over ice-free ocean
-      zcoef = xlsn / rhosn
+      !
+      zcoef = xlsn / rhosn                                        ! qns_tot update over free ocean with:
       ztmp(:,:) = p_frld(:,:,1) * zsnow(:,:) * zcoef
-      pqns_tot(:,:) = pqns_tot(:,:) - ztmp(:,:)
-      IF( lk_diaar5 )   CALL iom_put( 'hflx_snow_cea', ztmp + zsnow(:,:) * zcptn(:,:) )   ! heat flux from snow (cell average)
-!!gm
-!!    currently it is taken into account in leads budget but not in the qns_tot, and thus not in 
-!!    the flux that enter the ocean....
-!!    moreover 1 - it is not diagnose anywhere.... 
-!!             2 - it is unclear for me whether this heat lost is taken into account in the atmosphere or not...
-!!
-!! similar job should be done for snow and precipitation temperature
-      !                                                           ! Iceberg melting heat flux ....
-      !   energy for iceberg melting 
-      IF( srcv(jpr_cal)%laction ) THEN 
+      pqns_tot(:,:) = pqns_tot(:,:)                       &
+         &          - ztmp(:,:)                           &            ! remove the latent heat flux of solid precip. melting
+         &          + (  pemp_tot(:,:)                    &            ! remove the heat content of mass flux (assumed to be at SST)
+         &             - pemp_ice(:,:) * p_frld(:,:,1)  ) * zcptn(:,:) 
+         !
+      IF( lk_diaar5 )   CALL iom_put( 'hflx_snow_cea', ztmp(:,:) + zsnow(:,:) * zcptn(:,:) )   ! heat flux from snow (cell average)
+
+!!gm BUG ???   just above the right value should be : ztmp + zsnow*p_frld*zcptn
+
+      !                               
+      IF( srcv(jpr_cal)%laction ) THEN                                 ! remove the latent heat flux of iceberg melting
          zcoef = xlic / rhoic
          ztmp(:,:) = frcv(:,:,jpr_cal) * zcoef
          pqns_tot(:,:) = pqns_tot(:,:) - ztmp(:,:)
+         !
          IF( lk_diaar5 )   CALL iom_put( 'hflx_cal_cea', ztmp + frcv(:,:,jpr_cal) * zcptn(:,:) )   ! heat flux from calving
       ENDIF
Index: /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcflx.F90
===================================================================
--- /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcflx.F90	(revision 1858)
+++ /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcflx.F90	(revision 1859)
@@ -4,5 +4,6 @@
    !! Ocean forcing:  momentum, heat and freshwater flux formulation
    !!=====================================================================
-   !! History :  9.0   !  06-06  (G. Madec)  Original code
+   !! History :  1.0  !  2006-06  (G. Madec)  Original code
+   !!            3.3  !  2010-05  (Y. Aksenov G. Madec) salt flux + heat associated with emp
    !!----------------------------------------------------------------------
 
@@ -52,5 +53,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010)
    !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
@@ -74,6 +75,5 @@
       !!
       !!      CAUTION :  - never mask the surface stress fields
-      !!                 - the stress is assumed to be in the mesh referential
-      !!                   i.e. the (i,j) referential
+      !!                 - the stress is assumed to be in the (i,j) mesh referential
       !!
       !! ** Action  :   update at each time-step
@@ -81,6 +81,7 @@
       !!              - taum        wind stress module at T-point
       !!              - wndm        10m wind module at T-point
-      !!              - qns, qsr    non-slor and solar heat flux
-      !!              - emp, emps   evaporation minus precipitation
+      !!              - qns         non solar heat flux including heat flux due to emp
+      !!              - qsr         solar heat flux
+      !!              - emp         upward mass flux (evap. - precip.)
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt   ! ocean time step
@@ -136,10 +137,7 @@
       ENDIF
 
-      CALL fld_read( kt, nn_fsbc, sf )           ! Read input fields and provides the
-      !                                          ! input fields at the current time-step
+      CALL fld_read( kt, nn_fsbc, sf )           ! input fields at the current time-step
 
-      IF( MOD( kt-1, nn_fsbc ) == 0 ) THEN
-         !
-         ! set the ocean fluxes from read fields
+      IF( MOD( kt-1, nn_fsbc ) == 0 ) THEN       ! set the ocean fluxes from read fields
 !CDIR COLLAPSE
          DO jj = 1, jpj
@@ -151,8 +149,9 @@
                emp (ji,jj) = sf(jp_emp )%fnow(ji,jj)
             END DO
-         END DO
-         
-         ! module of wind stress and wind speed at T-point
-         zcoef = 1. / ( zrhoa * zcdrag ) 
+         END DO         
+         !                                       ! add to qns the heat due to e-p
+         qns(:,:) = qns(:,:) - emp(:,:) * sst_m(:,:) * rcp      ! mass flux are at SST
+
+         zcoef = 1. / ( zrhoa * zcdrag )         ! module of wind stress and wind speed at T-point
 !CDIR NOVERRCHK
          DO jj = 2, jpjm1
@@ -167,10 +166,6 @@
          END DO
          CALL lbc_lnk( taum(:,:), 'T', 1. )   ;   CALL lbc_lnk( wndm(:,:), 'T', 1. )
-
-         ! Initialization of emps (when no ice model)
-         emps(:,:) = emp (:,:) 
                   
-         ! control print (if less than 100 time-step asked)
-         IF( nitend-nit000 <= 100 .AND. lwp ) THEN
+         IF( nitend-nit000 <= 100 .AND. lwp ) THEN      ! control print (if less than 100 time-step asked)
             WRITE(numout,*) 
             WRITE(numout,*) '        read daily momentum, heat and freshwater fluxes OK'
